#ifndef StatistikLeser_H
#define StatistikLeser_H

#include "../Aufzeichnung/Bestenliste/VideoBestenliste.h"
#include "../Aufzeichnung/Karte/VideoKarte.h"
#include "../Aufzeichnung/Spieler/VideoSpieler.h"
#include "../Aufzeichnung/Nachricht/VideoNachricht.h"
#include "../SpielStatistik/SpielStatistikDaten.h"

class StatistikLeser : public virtual ReferenceCounter
{
private:
    SpielNachricht *nachrichten;
    VideoBestenliste *bestenliste;
    VideoKarte *map;
    RCArray< VideoSpieler > *spieler;
    Array< SSDGesamtSpieler * > *ssdgs;
    Array< SSDGesamtTeam * > *ssdgt;
    Array< SSDRunde * > *ssdr;
    int spielerAnzahl;
    int teamAnzahl;
    int rundenAnzahl;
    bool fehler;

public:
    // Konstruktor
    StatistikLeser( int spielId );
    // Destruktor
    ~StatistikLeser();
    // constant
    bool hatFehler() const;
    int getSpielerAnzahl() const;
    int getTeamAnzahl() const;
    int getRundenAnzahl() const;
    SSDGesamtSpieler *getSSDGS( int index ) const;
    SSDGesamtTeam *getSSDGT( int index ) const;
    SSDRunde *getSSDR( int runde ) const;
};

#endif