#ifndef Kamera_H
#define Kamera_H

#include <Bild.h>
#include <Rahmen.h>

using namespace Framework;

class Karte;

class Kamera : public virtual ReferenceCounter
{
private:
    Punkt pos;
    Punkt gr;
    Punkt rGr;
    LRahmen *rahmen;

public:
    // Konstruktor
    Kamera();
    // Destruktor
    ~Kamera();
    // nicht constant
    void setPosition( int x, int y );
    void addPosition( int x, int y, Karte *zMap );
    void setSize( int br, int h );
    void render( Bild &zRObj );
    // constant
    int getLinks() const;
    int getOben() const;
    int getRechts() const;
    int getUnten() const;
    bool istSichtbar( int x, int y ) const;
    bool istMausIn( int x, int y ) const;
    int getRX( int mapX ) const;
    int getRY( int mapY ) const;
    int getX() const;
    int getY() const;
};

#endif