#ifndef Spieler_H
#define Spieler_H

#define TICK 0.03333333
#include <KSGNetwork.h>
#include "..\Kamera\Kamera.h"

class Spieler : public virtual ReferenceCounter
{
private:
    double xPos;
    double yPos;
    double xSpeed;
    double ySpeed;
    double kurve;
    bool lKurve;
    bool rKurve;
    int spielerNummer;
    int team;
    int radius;
    bool amLeben;
    bool linieUnterbrochen;
    int accId;
    KSGClient::InformationServerClient *info;
    Text *name;
    LRahmen *teamRahmen;
    int spielerFarbe;
    int teamFarbe;

public:
    // Konstruktor
    Spieler( KSGClient::InformationServerClient *zInfoK );
    // Destruktor
    ~Spieler();
    // nicht constant
    void neuRunde();
    void setAccountId( int accId );
    void setSpielerNummer( int num );
    void setTeam( int team );
    void setTeamFarbe( int fc );
    void setSpielerFarbe( int fc );
    void setPos( double x, double y );
    void setRadius( int r );
    void setSpeed( double xSpeed, double ySpeed );
    void setKurveSpeed( double kurve );
    void setLinksKurve( Bild *zMap, bool lKurve, double sendeZeit, double spielZeit );
    void setRechtsKurve( Bild *zMap, bool rKurve, double sendeZeit, double spielzeit );
    void sterben( Bild *zMap, double sendeZeit, double spielZeit );
    void sterben();
    void setLinienUnterbrechung( Bild *zMap, bool unterbrechung, double sendeZeit, double spielZeit );
    void prozessKurve( double zeit );
    void tick( Bild *zMap, double zeit );
    void render( Kamera *zKam, Bild &zRObj );
    // constant
    double getX() const;
    double getY() const;
    int getTeam() const;
    int getTeamFarbe() const;
    int getFarbe() const;
    int getSpielerNummer() const;
    bool istAmLeben() const;
    int getAccountId() const;
    Text *getName() const;
    Text *zName() const;
};

#endif